// datetime.cpp
//
// Example program creates date and time objects and shows the
// different kinds of display styles that can be used.

#include <cm/include/cmdate.h>
#include <cm/include/cmtime.h>

int main()
{
  CmDate today;            // Create a date object and show all possible
                           // display styles.

  cout << "Date Display" << endl << "------------" << endl;
  cout << "Default      = " << today << endl;
  cout << "Normal date  = " << dateNormal  << today << endl;
  cout << "Numbers date = " << dateNumbers << today << endl;

  CmTime now;              // Create a time object and show all possible
                           // display styles.

  cout << endl << "Time Display" << endl << "------------" << endl;
  cout << "Default              = " << now << endl;
  cout << "12 hour with no date = " << time12Hour << now << endl;
  cout << "24 hour with no date = " << time24Hour << now << endl;
  cout << "12 hour with date    = " << time12Hour << timeDate   << now << endl;
  cout << "12 hour with no date = " << time12Hour << timeNoDate << now << endl;
  cout << "24 hour with date    = " << time24Hour << timeDate   << now << endl;
  cout << "24 hour with no date = " << time24Hour << timeNoDate << now << endl;

  // Since the time class uses the date class to display the date,
  // the date and time manipulators can be combined as in the following.
  cout << endl << "24 hour with numbers date = ";
  cout << dateNumbers << time24Hour << timeDate << now << endl;
  return 0;
}
