// strin.cpp
//
// Example program uses the string class and the binary tree class.
// Strings are read one at a time and inserted into the binary tree
// until an 'x' (exit) is typed.  An iterator is then created and
// used to cycle through the tree printing each string to standard
// out.

#include <cm/include/cmbintr.h>
#include <cm/include/cmstring.h>

int main()                                       // Start main.
{
  CmBinaryTree tree;                             // Binary tree container.
  CmString     input;                            // Input string.
  bool         finished = false;                 // boolean data type.

  while (!finished)                              // While boolean is true,
  {
    cout << "Enter string (\"x\" when done): " << flush;
    cin  >> input;                               // Read string input.

    if (input.length() == 1 && input[0] == 'x')  // If "x" then finished.
      finished = true;

    else if (input.length() > 0)                 // Add string to tree.
      tree.add(new CmString(input));
  }

  CmBinaryTreeIterator iter(tree);               // Create an iterator.

  while (iter)                                   // Print all objects.
    cout << *iter++ << endl;

  return 0;
}
