// taverage.cpp
//
// Example program uses the array template.  The program reads in a set
// of test scores with values between 0 and 100, stuffs each one into an
// array, computes the average score, and prints the score to standard
// out.  This example is the template version of "average.cpp".  Using
// a template really gets rid of the need for the integer class.

#include <iostream.h>
#include <cm/include/cmtarray.h>

const int MIN = 0;                               // Define minimum and
const int MAX = 100;                             // maximum score constants.

int main()                                       // Start main.
{
  CmTArray<int> array;                           // Declare 0 size array.
  int           nScores;                         // Number of scores.

  cout << "How many scores will you enter: " << flush;
  cin  >> nScores;                               // Read in number of scores.

  array.resize(nScores);                         // Set array size.

  int input, ii = 0;                             // Input score and counter.
  while (ii < nScores)                           // While still in range,
  {
    cout << "Score " << ++ii << ": " << flush;
    cin  >> input;                               // read score.

    if (input < MIN || input > MAX)              // Check score range.
    {
      cout << "Score must be between " << MIN << // Bad range.
              " and " << MAX << endl;
      ii--;
    }

    else
      array.add(input);                          // Copy score into array.
  }

  CmTArrayIterator<int> iter(array);             // Create an iterator.
  int                   average = 0;             // Start total at zero.
 
  while (iter)                                   // Add all the scores.
    average += iter++;
                                                 // Print average.
  cout << "\nAverage score is " << average / nScores << ".\n";

  return 0;
}
