// tstrin.cpp
//
// Example program uses the string class and the binary tree template.
// Strings are read one at a time and inserted into the tree template
// until an 'x' (exit) is typed.  An iterator template is then created
// and used to cycle through the tree printing each string to standard
// out.

#include <cm/include/cmtbintr.h>
#include <cm/include/cmstring.h>

int main()                                       // Start main.
{
  CmTBinaryTree<CmString> tree;                  // Binary tree template.
  CmString                input;                 // Input string.
  bool                    finished = false;      // boolean data type.

  while (!finished)                              // While boolean is true,
  {
    cout << "Enter string (\"x\" when done): " << flush;
    cin  >> input;                               // Read string input.

    if (input.length() == 1 && input[0] == 'x')  // If "x" then finished.
      finished = true;

    else if (input.length() > 0)                 // Add string to tree.
      tree.add(input);                           // String is copied.
  }

  CmTBinaryTreeIterator<CmString> iter(tree);    // Iterator template.

  while (iter)                                   // Print all items.
    cout << iter++ << endl;

  return 0;
}
