// cmbset.h
// -----------------------------------------------------------------
// Compendium - C++ Container Class Library
// Copyright (C) 1992-1995, Glenn M. Poorman, All rights reserved
// -----------------------------------------------------------------
// BTree set definition.
// -----------------------------------------------------------------

#ifndef _CMBSET_H
#define _CMBSET_H

#include <cm/include/cmbtree.h>

class CmBTreeSet : public CmBTree {              // Set class definition.
public:
  CmBTreeSet(unsigned = 3);                      // Default set constructor.
  CmBTreeSet(const CmBTreeSet&);                 // Set copy constructor.
  CmBTreeSet(const CmContainer&);                // Construct from container.
 ~CmBTreeSet() {}                                // Set destructor.

  CmBTreeSet& operator=(const CmBTreeSet&);      // Assignment operator.

  CmBTreeSet operator-(const CmBTreeSet&) const; // Set difference.
  CmBTreeSet operator&(const CmBTreeSet&) const; // Set intersection.
  CmBTreeSet operator|(const CmBTreeSet&) const; // Set union.

  bool add(CmObject*);                           // Add object to set.

  CMOBJECT_DEFINE(CmBTreeSet)                    // Define object funcs.
};

#endif
