// cmdefs.h
// -----------------------------------------------------------------
// Compendium - C++ Container Class Library
// Copyright (C) 1992-1995, Glenn M. Poorman, All rights reserved
// -----------------------------------------------------------------
// Definitions used throughout the Compendium library.
// -----------------------------------------------------------------

#ifndef _CMDEFS_H
#define _CMDEFS_H

// Define NO_STANDARD_BOOL for all compilers except GNU.  The plan
// is that, down the road, we'll be able to do away with this define.
#if !defined(__GNUG__)
#  define NO_STANDARD_BOOL 1
#endif

#if defined(NO_STANDARD_BOOL)
#  ifndef bool
#    define bool int
#  endif
#  ifndef false
#    define false 0
#  endif
#  ifndef true
#    define true 1
#  endif
#  ifndef Bool
#    define Bool int
#  endif
#  ifndef FALSE
#    define FALSE 0
#  endif
#  ifndef TRUE
#    define TRUE 1
#  endif
#else
#  ifndef Bool
#    define Bool bool
#  endif
#  ifndef FALSE
#    define FALSE false
#  endif
#  ifndef TRUE
#    define TRUE true
#  endif
#endif

// For GNU compiler, undefine "#define NULL (void*)0".
#if defined(__GNUG__) && defined(NULL)
#  undef NULL
#endif

#ifndef NULL
#define NULL 0
#endif

// "CmAbs" absolute value macro.
#define CmAbs(data) ((data) >= 0) ? (data) : -(data)

// "CmMax" maximum value macro.
#define CmMax(a,b) ((a) >= (b)) ? (a) : (b)

// "CmMin" minimum value macro.
#define CmMin(a,b) ((a) <= (b)) ? (a) : (b)

#endif
