// cmdict.h
// -----------------------------------------------------------------
// Compendium - C++ Container Class Library
// Copyright (C) 1992-1995, Glenn M. Poorman, All rights reserved
// -----------------------------------------------------------------
// Dictionary definition.
// -----------------------------------------------------------------

#ifndef _CMDICT_H
#define _CMDICT_H

#include <cm/include/cmdlist.h>
#include <cm/include/cmassoc.h>

class CmDictionary : public CmDLinkedList {           // Dictionary definition.
public:
  CmDictionary();                                     // Default constructor.
  CmDictionary(const CmDictionary&);                  // Copy constructor.
 ~CmDictionary();                                     // Destructor.

  CmDictionary& operator=(const CmDictionary&);       // Assignment op.

  bool add      (CmObject*);                          // Add association.
  bool add      (CmObject*, CmObject*);               // Add key and object.
  bool replace  (const CmObject*, CmObject*);         // Replace object at key.
  bool remove   (const CmObject*);                    // Remove key and object.
  bool remove   (const CmIterator&);                  // Remove iterator object.
  void removeAll();                                   // Remove all objects.

  CmObject*      lookup      (const CmObject*) const; // Key from key.
  CmObject*      lookupObject(const CmObject*) const; // Object from key.
  CmAssociation* lookupAssoc (const CmObject*) const; // Association from key.
  bool           contains    (const CmObject*) const; // Key in dictionary?
  unsigned       occurrences (const CmObject*) const; // Occurrences of key.

  CMOBJECT_DEFINE(CmDictionary)                       // Define object funcs.
};

#endif
