// cmhdict.h
// -----------------------------------------------------------------
// Compendium - C++ Container Class Library
// Copyright (C) 1992-1995, Glenn M. Poorman, All rights reserved
// -----------------------------------------------------------------
// Hash dictionary definition.
// -----------------------------------------------------------------

#ifndef _CMHDICT_H
#define _CMHDICT_H

#include <cm/include/cmhash.h>
#include <cm/include/cmassoc.h>

class CmHashDictionary : public CmHashTable {         // Dictionary definition.
public:
  CmHashDictionary(unsigned = 10);                    // Default constructor.
  CmHashDictionary(const CmHashDictionary&);          // Copy constructor.
 ~CmHashDictionary();                                 // Destructor.

  CmHashDictionary& operator=(const CmHashDictionary&); // Assignment operator.

  bool add      (CmObject*);                          // Add association.
  bool add      (CmObject*, CmObject*);               // Add key and object.
  bool replace  (const CmObject*, CmObject*);         // Replace object at key.
  bool remove   (const CmObject*);                    // Remove key and object.
  bool remove   (const CmIterator&);                  // Remove iterator object.
  void removeAll();                                   // Remove all objects.

  CmObject*      lookup      (const CmObject*) const; // Key from key.
  CmObject*      lookupObject(const CmObject*) const; // Object from key.
  CmAssociation* lookupAssoc (const CmObject*) const; // Association from key.
  bool           contains    (const CmObject*) const; // Key in dictionary?
  unsigned       occurrences (const CmObject*) const; // Occurrences of key.

  CMOBJECT_DEFINE(CmHashDictionary)                   // Define object funcs.
};

#endif
