// cmhset.h
// -----------------------------------------------------------------
// Compendium - C++ Container Class Library
// Copyright (C) 1992-1995, Glenn M. Poorman, All rights reserved
// -----------------------------------------------------------------
// Hash Table set definition.
// -----------------------------------------------------------------

#ifndef _CMHSET_H
#define _CMHSET_H

#include <cm/include/cmhash.h>

class CmHashSet : public CmHashTable {         // Set class definition.
public:
  CmHashSet(unsigned = 10);                    // Default set constructor.
  CmHashSet(const CmHashSet&);                 // Set copy constructor.
  CmHashSet(const CmContainer&);               // Construct from container.
 ~CmHashSet() {}                               // Set destructor.

  CmHashSet& operator=(const CmHashSet&);      // Assignment operator.

  CmHashSet operator-(const CmHashSet&) const; // Set difference.
  CmHashSet operator&(const CmHashSet&) const; // Set intersection.
  CmHashSet operator|(const CmHashSet&) const; // Set union.

  bool add(CmObject*);                         // Add object to set.

  CMOBJECT_DEFINE(CmHashSet)                   // Define object funcs.
};

#endif
