// cmtbag.h
// -----------------------------------------------------------------
// Compendium - C++ Container Class Library
// Copyright (C) 1992-1995, Glenn M. Poorman, All rights reserved
// -----------------------------------------------------------------
// Bag template definition.
// -----------------------------------------------------------------

#ifndef _CMTBAG_H
#define _CMTBAG_H

#include <cm/include/cmthash.h>

template <class T> class CmTBag : public CmTHashTable<T> {  // Bag definition.
public:
  CmTBag(unsigned = 10);                       // Default bag constructor.
  CmTBag(CmTHashFunc, unsigned = 10);          // Construct with hash func.
  CmTBag(const CmTBag<T>&);                    // Bag copy constructor.
  CmTBag(CmTHashFunc, const CmTContainer<T>&); // Construct from container.
 ~CmTBag() {}                                  // Bag destructor.

  CmTBag<T>& operator=(const CmTBag<T>&);      // Assignment operator.
};

#if defined(__TURBOC__) || defined(__xlC__) || defined(_MSC_VER) || defined(__GNUG__)
#include <cm/include/cmtbag.cc>
#endif

#endif
