// cmtbdict.h
// -----------------------------------------------------------------
// Compendium - C++ Container Class Library
// Copyright (C) 1992-1995, Glenn M. Poorman, All rights reserved
// -----------------------------------------------------------------
// BTree dictionary template definition.
// -----------------------------------------------------------------

#ifndef _CMTBDICT_H
#define _CMTBDICT_H

#include <cm/include/cmtbtree.h>
#include <cm/include/cmtassoc.h>

template <class T, class O>
class CmTBTreeDictionary : public CmTBTree< CmTAssociation<T, O> > {
public:
  CmTBTreeDictionary(unsigned = 3);                   // Default constructor.
  CmTBTreeDictionary(const CmTBTreeDictionary<T,O>&); // Copy constructor.
 ~CmTBTreeDictionary() {}                             // Destructor.

                                                      // Assignment.
  CmTBTreeDictionary<T,O>& operator=(const CmTBTreeDictionary<T,O>&);

  bool addKey         (const T&);                     // Add key.
  bool addKeyAndObject(const T&, const O&);           // Add assoc.
  bool addAssoc       (const CmTAssociation<T,O>&);   // Add assoc.
  bool replace        (const T&, const O&);           // Rep obj at key.
  bool removeKey      (const T&);                     // Remove assoc with key.

  const T& lookupKey       (const T&) const;          // Return equal key.
  const O& lookupObject    (const T&) const;          // Return object by key.
  bool     containsKey     (const T&) const;          // See if key in dict.
  unsigned occurrencesOfKey(const T&) const;          // How many equal keys.

  const CmTAssociation<T,O>& lookupAssoc(const T&) const;  // Lookup assoc.
};

#if defined(__TURBOC__) || defined(__xlC__) || defined(_MSC_VER) || defined(__GNUG__)
#include <cm/include/cmtbdict.cc>
#endif

#endif
