// cmtbset.h
// -----------------------------------------------------------------
// Compendium - C++ Container Class Library
// Copyright (C) 1992-1995, Glenn M. Poorman, All rights reserved
// -----------------------------------------------------------------
// BTree set template definition.
// -----------------------------------------------------------------

#ifndef _CMTBSET_H
#define _CMTBSET_H

#include <cm/include/cmtbtree.h>

template <class T> class CmTBTreeSet : public CmTBTree<T> {
public:
  CmTBTreeSet(unsigned = 3);                             // Default constructor.
  CmTBTreeSet(const CmTBTreeSet<T>&);                    // Set copy constructor.
  CmTBTreeSet(const CmTContainer<T>&);                   // Container copy.
 ~CmTBTreeSet() {}                                       // Set destructor.

  CmTBTreeSet<T>& operator=(const CmTBTreeSet<T>&);      // Assignment operator.

  CmTBTreeSet<T> operator-(const CmTBTreeSet<T>&) const; // Set difference.
  CmTBTreeSet<T> operator&(const CmTBTreeSet<T>&) const; // Set intersection.
  CmTBTreeSet<T> operator|(const CmTBTreeSet<T>&) const; // Set union.

  bool add(const T&);                                    // Add item to set.
};

#if defined(__TURBOC__) || defined(__xlC__) || defined(_MSC_VER) || defined(__GNUG__)
#include <cm/include/cmtbset.cc>
#endif

#endif
