// cmtdict.h
// -----------------------------------------------------------------
// Compendium - C++ Container Class Library
// Copyright (C) 1992-1995, Glenn M. Poorman, All rights reserved
// -----------------------------------------------------------------
// Dictionary template definition.
// -----------------------------------------------------------------

#ifndef _CMTDICT_H
#define _CMTDICT_H

#include <cm/include/cmtdlist.h>
#include <cm/include/cmtassoc.h>

template <class T, class O>
class CmTDictionary : public CmTDLinkedList< CmTAssociation<T, O> > {
public:
  CmTDictionary() {}                                  // Default constructor.
  CmTDictionary(const CmTDictionary<T,O>&);           // Copy constructor.
 ~CmTDictionary() {}                                  // Destructor.

  CmTDictionary<T,O>& operator=(const CmTDictionary<T,O>&); // Assignment.

  bool addKey         (const T&);                     // Add key.
  bool addKeyAndObject(const T&, const O&);           // Add assoc.
  bool addAssoc       (const CmTAssociation<T,O>&);   // Add assoc.
  bool replace        (const T&, const O&);           // Rep obj at key.
  bool removeKey      (const T&);                     // Remove assoc with key.

  const T& lookupKey       (const T&) const;          // Return equal key.
  const O& lookupObject    (const T&) const;          // Return object by key.
  bool     containsKey     (const T&) const;          // See if key in dict.
  unsigned occurrencesOfKey(const T&) const;          // How many equal keys.

  const CmTAssociation<T,O>& lookupAssoc(const T&) const;  // Lookup assoc.
};

#if defined(__TURBOC__) || defined(__xlC__) || defined(_MSC_VER) || defined(__GNUG__)
#include <cm/include/cmtdict.cc>
#endif

#endif
