// cmthset.h
// -----------------------------------------------------------------
// Compendium - C++ Container Class Library
// Copyright (C) 1992-1995, Glenn M. Poorman, All rights reserved
// -----------------------------------------------------------------
// Hash table set template definition.
// -----------------------------------------------------------------

#ifndef _CMTHSET_H
#define _CMTHSET_H

#include <cm/include/cmthash.h>

template <class T> class CmTHashSet : public CmTHashTable<T> {
public:
  CmTHashSet(unsigned = 10);                           // Default constructor.
  CmTHashSet(CmTHashFunc, unsigned = 10);              // Construct with hasher.
  CmTHashSet(const CmTHashSet<T>&);                    // Set copy constructor.
  CmTHashSet(CmTHashFunc, const CmTContainer<T>&);     // Container copy.
 ~CmTHashSet() {}                                      // Set destructor.

  CmTHashSet<T>& operator=(const CmTHashSet<T>&);      // Assignment operator.

  CmTHashSet<T> operator-(const CmTHashSet<T>&) const; // Set difference.
  CmTHashSet<T> operator&(const CmTHashSet<T>&) const; // Set intersection.
  CmTHashSet<T> operator|(const CmTHashSet<T>&) const; // Set union.

  bool add(const T&);                                  // Add item to set.
};

#if defined(__TURBOC__) || defined(__xlC__) || defined(_MSC_VER) || defined(__GNUG__)
#include <cm/include/cmthset.cc>
#endif

#endif
