// cmbag.cpp
// -----------------------------------------------------------------
// Compendium - C++ Container Class Library
// Copyright (C) 1992-1995, Glenn M. Poorman, All rights reserved
// -----------------------------------------------------------------
// Bag implementation.
// -----------------------------------------------------------------

#include <cm/include/cmbag.h>

// Macro call initializes the static type info data.
CMOBJECT_INIT(CmBag, CmHashTable)

// Macro registers this class for binary file I/O.
CMOBJECT_REGISTER(CmBag)


// "CmBag" is the default bag constructor.
//
CmBag::CmBag(unsigned sz) : CmHashTable(sz)
{}


// "CmBag" is the bag copy constructor.
//
CmBag::CmBag(const CmBag& bag) : CmHashTable(bag)
{}


// "CmBag" constructs a bag from the specified container.
//
CmBag::CmBag(const CmContainer& cont) : CmHashTable(cont.total())
{
  copy(cont);
}


// "=" assignment operator copies the contents of the specified
// bag into this bag.
//
CmBag& CmBag::operator=(const CmBag& bag)
{
  return (CmBag&) CmHashTable::operator=(bag);
}
