// cmiter.cpp
// -----------------------------------------------------------------
// Compendium - C++ Container Class Library
// Copyright (C) 1992-1995, Glenn M. Poorman, All rights reserved
// -----------------------------------------------------------------
// Abstract container iterator implementation.
// -----------------------------------------------------------------

#include <cm/include/cmiter.h>

// Macro call initializes the static type info data.
CMOBJECT_INIT(CmIterator, CmObject)


// "next" advances the iterator to the next occurrence of
// the specified object.
//
CmObject* CmIterator::next(CmObject* pObj)
{
  while (!done() && !(current()->isEqual(pObj))) next();
  CmObject *out = (done()) ? NULL : current(); next();
  return out;
}


// "previous" advances the iterator to the previous occurrence of
// the specified object.
//
CmObject* CmIterator::previous(CmObject* pObj)
{
  while (!done() && !(current()->isEqual(pObj))) previous();
  CmObject *out = (done()) ? NULL : current(); previous();
  return out;
}


// "+=" advances the iterator n places and returns the object.
//
CmObject* CmIterator::operator+=(int num)
{
  for (int ii = 0; ii < num; ii++) next();
  return current();
}


// "-=" decrements the iterator n places and returns the object.
//
CmObject* CmIterator::operator-=(int num)
{
  for (int ii = 0; ii < num; ii++) previous();
  return current();
}
