// cmtypinf.cpp
// -----------------------------------------------------------------
// Compendium - C++ Container Class Library
// Copyright (C) 1992-1995, Glenn M. Poorman, All rights reserved
// -----------------------------------------------------------------
// Type id and type info class implementations.
// -----------------------------------------------------------------

#include <cm/include/cmtypinf.h>

// Macro initializes the type info data.
CMTYPEID_INIT_BASE(CmTypeInfo)


// "CmTypeInfo" is the type info constructor.
//
CmTypeInfo::CmTypeInfo(const char* str, const CmTypeInfo* baselist[])
          : _name(str), _bases(baselist)
{}


// "hasBase" looks through this type info's list of base classes and
// also looks through the base classes of the base classes to see if
// this type derives (directly or indirectly) from the type of the
// specified info.
//
bool CmTypeInfo::hasBase(const CmTypeInfo* bs) const
{
  bool found = false;
  if (_bases)
  {
    int ii = 0;
    while (_bases[ii])
    {
      if (_bases[ii] == bs || _bases[ii]->hasBase(bs))
        found = true;
      ii++;
    }
  }
  return found;
}
