// teststr.cxx
// -----------------------------------------------------------------
// Compendium - C++ Container Class Library
// Copyright (C) 1992-1995, Glenn M. Poorman, All rights reserved
// -----------------------------------------------------------------
// Functions for string and vector class testing.
// -----------------------------------------------------------------

#include "testbase.h"
#include <cm/include/cmtvec.h>

// "testString" tests the string class.
//
void testString()
{
  cout << "Testing string class." << endl;

  CmString temp = "Glenn";
  assert(temp == "Glenn");
  assert(temp <  "Mom");
  assert(temp >  "Bob");

  assert(temp.assign("Compendium ") == "Compendium ");
  assert(temp.append("Containers") == "Compendium Containers");
  assert(temp.insert(11, "1.1 ") == "Compendium 1.1 Containers");
  assert(temp.replace(11, 3, "2.0") == "Compendium 2.0 Containers");
  assert(temp.remove(11, 4) == "Compendium Containers");
  assert(temp.index("Containers") == 11);
  assert(temp(11, 4) == "Cont");
}


// "testVector" tests the vector class.
//
void testVector()
{
  cout << "Testing vector class." << endl;

  CmString list1[3], list2[3];

  list1[0] = "one";  list1[1] = "two";  list1[2] = "three";
  list2[0] = "four"; list2[1] = "five"; list2[2] = "six";

  CmTVector<CmString> vec(3,list1);
  assert(vec[0] == "one");
  assert(vec[1] == "two");
  assert(vec[2] == "three");

  vec.assign(list2, 3);
  assert(vec[0] == "four");
  assert(vec[1] == "five");
  assert(vec[2] == "six");

  vec.append("seven");
  assert(vec[3] == "seven");

  vec.insert(2, "two.five");
  assert(vec[2] == "two.five");

  assert(vec.size() == 5);
  vec.remove(2, 1);
  assert(vec.size() == 4);

  vec.clear();
  assert(vec.size() == 0);
}
